<?php
/* ------------------------------------------------------------------------- *
 *  Dynamic styles
/* ------------------------------------------------------------------------- */

/*  Convert hexadecimal to rgb
/* ------------------------------------ */
if ( ! function_exists( 'minimer_hex2rgb' ) ) {

	function minimer_hex2rgb( $hex, $array=false ) {
		$hex = str_replace("#", "", $hex);

		if ( strlen($hex) == 3 ) {
			$r = hexdec(substr($hex,0,1).substr($hex,0,1));
			$g = hexdec(substr($hex,1,1).substr($hex,1,1));
			$b = hexdec(substr($hex,2,1).substr($hex,2,1));
		} else {
			$r = hexdec(substr($hex,0,2));
			$g = hexdec(substr($hex,2,2));
			$b = hexdec(substr($hex,4,2));
		}

		$rgb = array( $r, $g, $b );
		if ( !$array ) { $rgb = implode(",", $rgb); }
		return $rgb;
	}
	
}	


/*  Google fonts
/* ------------------------------------ */
if ( ! function_exists( 'minimer_enqueue_google_fonts' ) ) {

	function minimer_enqueue_google_fonts () {
		if ( get_theme_mod('dynamic-styles', 'on') == 'on' ) {
			if ( get_theme_mod( 'font' ) == 'titillium-web-ext' ) { wp_enqueue_style( 'titillium-web-ext', '//fonts.googleapis.com/css?family=Titillium+Web:400,400italic,300italic,300,600&subset=latin,latin-ext' ); }		
			if ( get_theme_mod( 'font' ) == 'droid-serif' )	{ wp_enqueue_style( 'droid-serif', '//fonts.googleapis.com/css?family=Droid+Serif:400,400italic,700' ); }				
			if ( get_theme_mod( 'font' ) == 'source-sans-pro' )	{ wp_enqueue_style( 'source-sans-pro', '//fonts.googleapis.com/css?family=Source+Sans+Pro:400,300italic,300,400italic,600&subset=latin,latin-ext' ); }
			if ( get_theme_mod( 'font' ) == 'lato' ) { wp_enqueue_style( 'lato', '//fonts.googleapis.com/css?family=Lato:400,300,300italic,400italic,700' ); }
			if ( get_theme_mod( 'font' ) == 'raleway' )	{ wp_enqueue_style( 'raleway', '//fonts.googleapis.com/css?family=Raleway:400,300,600' ); }
			if ( get_theme_mod( 'font' ) == 'ubuntu' ) { wp_enqueue_style( 'ubuntu', '//fonts.googleapis.com/css?family=Ubuntu:400,400italic,300italic,300,700&subset=latin,latin-ext' ); }
			if ( get_theme_mod( 'font' ) == 'ubuntu-cyr' ) { wp_enqueue_style( 'ubuntu-cyr', '//fonts.googleapis.com/css?family=Ubuntu:400,400italic,300italic,300,700&subset=latin,cyrillic-ext' ); }
			/*default*/ if ( ( get_theme_mod( 'font' ) == '' ) || ( get_theme_mod( 'font' ) == 'roboto' ) ) { wp_enqueue_style( 'roboto', '//fonts.googleapis.com/css?family=Roboto:400,300italic,300,400italic,700&subset=latin,latin-ext' ); }
			if ( get_theme_mod( 'font' ) == 'roboto-cyr' ) { wp_enqueue_style( 'roboto-cyr', '//fonts.googleapis.com/css?family=Roboto:400,300italic,300,400italic,700&subset=latin,cyrillic-ext' ); }
			if ( get_theme_mod( 'font' ) == 'roboto-condensed' ) { wp_enqueue_style( 'roboto-condensed', '//fonts.googleapis.com/css?family=Roboto+Condensed:400,300italic,300,400italic,700&subset=latin,latin-ext' ); }
			if ( get_theme_mod( 'font' ) == 'roboto-condensed-cyr' ) { wp_enqueue_style( 'roboto-condensed-cyr', '//fonts.googleapis.com/css?family=Roboto+Condensed:400,300italic,300,400italic,700&subset=latin,cyrillic-ext' ); }
			if ( get_theme_mod( 'font' ) == 'roboto-slab' ) { wp_enqueue_style( 'roboto-slab', '//fonts.googleapis.com/css?family=Roboto+Slab:400,300italic,300,400italic,700&subset=latin,latin-ext' ); }
			if ( get_theme_mod( 'font' ) == 'roboto-slab-cyr' ) { wp_enqueue_style( 'roboto-slab-cyr', '//fonts.googleapis.com/css?family=Roboto+Slab:400,300italic,300,400italic,700&subset=latin,cyrillic-ext' ); }
			if ( get_theme_mod( 'font' ) == 'playfair-display' ) { wp_enqueue_style( 'playfair-display', '//fonts.googleapis.com/css?family=Playfair+Display:400,400italic,700&subset=latin,latin-ext' ); }
			if ( get_theme_mod( 'font' ) == 'playfair-display-cyr' ) { wp_enqueue_style( 'playfair-display-cyr', '//fonts.googleapis.com/css?family=Playfair+Display:400,400italic,700&subset=latin,cyrillic' ); }
			if ( get_theme_mod( 'font' ) == 'open-sans' ) { wp_enqueue_style( 'open-sans', '//fonts.googleapis.com/css?family=Open+Sans:400,400italic,300italic,300,600&subset=latin,latin-ext' ); }
			if ( get_theme_mod( 'font' ) == 'open-sans-cyr' ) { wp_enqueue_style( 'open-sans-cyr', '//fonts.googleapis.com/css?family=Open+Sans:400,400italic,300italic,300,600&subset=latin,cyrillic-ext' ); }
			if ( get_theme_mod( 'font' ) == 'pt-serif' ) { wp_enqueue_style( 'pt-serif', '//fonts.googleapis.com/css?family=PT+Serif:400,700,400italic&subset=latin,latin-ext' ); }
			if ( get_theme_mod( 'font' ) == 'pt-serif-cyr' ) { wp_enqueue_style( 'pt-serif-cyr', '//fonts.googleapis.com/css?family=PT+Serif:400,700,400italic&subset=latin,cyrillic-ext' ); }
		}
	}	
	
}
add_action( 'wp_enqueue_scripts', 'minimer_enqueue_google_fonts' ); 	


/*  Dynamic css output
/* ------------------------------------ */
if ( ! function_exists( 'minimer_dynamic_css' ) ) {

	function minimer_dynamic_css() {
		if ( get_theme_mod('dynamic-styles', 'on') == 'on' ) {
		
			// rgb values
			$color_1 = get_theme_mod('color-1');
			$color_1_rgb = minimer_hex2rgb($color_1);
			
			// start output
			$styles = '';		
			
			// google fonts
			if ( get_theme_mod( 'font' ) == 'titillium-web-ext' ) { $styles .= 'body { font-family: "Titillium Web", Arial, sans-serif; }'."\n"; }
			if ( get_theme_mod( 'font' ) == 'droid-serif' ) { $styles .= 'body { font-family: "Droid Serif", serif; }'."\n"; }
			if ( get_theme_mod( 'font' ) == 'source-sans-pro' ) { $styles .= 'body { font-family: "Source Sans Pro", Arial, sans-serif; }'."\n"; }
			if ( get_theme_mod( 'font' ) == 'lato' ) { $styles .= 'body { font-family: "Lato", Arial, sans-serif; }'."\n"; }
			if ( get_theme_mod( 'font' ) == 'raleway' ) { $styles .= 'body { font-family: "Raleway", Arial, sans-serif; }'."\n"; }
			if ( ( get_theme_mod( 'font' ) == 'ubuntu' ) || ( get_theme_mod( 'font' ) == 'ubuntu-cyr' ) ) { $styles .= 'body { font-family: "Ubuntu", Arial, sans-serif; }'."\n"; }	
			/*default*/ if ( ( get_theme_mod( 'font' ) == '' ) || ( get_theme_mod( 'font' ) == 'roboto' ) || ( get_theme_mod( 'font' ) == 'roboto-cyr' ) ) { $styles .= 'body { font-family: "Roboto", Arial, sans-serif; }'."\n"; }
			if ( ( get_theme_mod( 'font' ) == 'roboto-condensed' ) || ( get_theme_mod( 'font' ) == 'roboto-condensed-cyr' ) ) { $styles .= 'body { font-family: "Roboto Condensed", Arial, sans-serif; }'."\n"; }
			if ( ( get_theme_mod( 'font' ) == 'roboto-slab' ) || ( get_theme_mod( 'font' ) == 'roboto-slab-cyr' ) ) { $styles .= 'body { font-family: "Roboto Slab", Arial, sans-serif; }'."\n"; }			
			if ( ( get_theme_mod( 'font' ) == 'playfair-display' ) || ( get_theme_mod( 'font' ) == 'playfair-display-cyr' ) ) { $styles .= 'body { font-family: "Playfair Display", Arial, sans-serif; }'."\n"; }
			if ( ( get_theme_mod( 'font' ) == 'open-sans' ) || ( get_theme_mod( 'font' ) == 'open-sans-cyr' ) )	{ $styles .= 'body { font-family: "Open Sans", Arial, sans-serif; }'."\n"; }
			if ( ( get_theme_mod( 'font' ) == 'pt-serif' ) || ( get_theme_mod( 'font' ) == 'pt-serif-cyr' ) ) { $styles .= 'body { font-family: "PT Serif", serif; }'."\n"; }	
			if ( get_theme_mod( 'font' ) == 'arial' ) { $styles .= 'body { font-family: Arial, sans-serif; }'."\n"; }
			if ( get_theme_mod( 'font' ) == 'georgia' ) { $styles .= 'body { font-family: Georgia, serif; }'."\n"; }
			if ( get_theme_mod( 'font' ) == 'verdana' ) { $styles .= 'body { font-family: Verdana, sans-serif; }'."\n"; }
			if ( get_theme_mod( 'font' ) == 'tahoma' ) { $styles .= 'body { font-family: Tahoma, sans-serif; }'."\n"; }
			
			// container width
			if ( get_theme_mod('container-width','1380') != '1380' ) {			
				if ( get_theme_mod( 'boxed' ) ) { 
					$styles .= '.boxed #wrapper { max-width: '.esc_attr( get_theme_mod('container-width') ).'px; }'."\n";
				}
				else {
					$styles .= '.full-width #wrapper { max-width: '.esc_attr( get_theme_mod('container-width') ).'px; }'."\n";
				}
			}
			// content max-width
			if ( get_theme_mod('content-width','740') != '740' ) {
				$styles .= '
.entry-header,
.entry-content,
.entry-footer,
.pagination,
.page-title,
.page-title-inner,
.front-widgets { max-width: '.esc_attr( get_theme_mod('content-width') ).'px; }
				'."\n";
			}
			// content media max-width
			if ( get_theme_mod('content-media-width','940') != '940' ) {
				$styles .= '
.entry-media { max-width: '.esc_attr( get_theme_mod('content-media-width') ).'px; }
				'."\n";
			}
			// page content max-width
			if ( get_theme_mod('page-content-width','740') != '740' ) {
				$styles .= '
body.page .entry-header,
body.page .entry-content,
body.page .entry-footer { max-width: '.esc_attr( get_theme_mod('page-content-width') ).'px; }
				'."\n";
			}
			// link color
			if ( get_theme_mod('color-link','#000000') != '#000000' ) {
				$styles .= '
.entry a { color: '.esc_attr( get_theme_mod('color-link') ).'; }
				'."\n";
			}
			// sidebar color
			if ( get_theme_mod('color-sidebar','#333333') != '#333333' ) {
				$styles .= '
.s1,
.sidebar-skew-inner,
.sidebar-skew-bottom,
.profile-skew-inner,
.profile-skew-inner-bottom { background: '.esc_attr( get_theme_mod('color-sidebar') ).'; }
				'."\n";
			}
			// header line color
			if ( get_theme_mod('color-header-line','#333333') != '#333333' ) {
				$styles .= '
#wrapper { border-top-color: '.esc_attr( get_theme_mod('color-header-line') ).'; }
				'."\n";
			}
			// header line height
			if ( get_theme_mod('header-line-height','10') != '10' ) {
				$styles .= '
#wrapper { border-top-width: '.esc_attr( get_theme_mod('header-line-height') ).'px; }
				'."\n";
			}
			// header color
			if ( get_theme_mod('color-header','#ffffff') != '#ffffff' ) {
				$styles .= '
#header { background: '.esc_attr( get_theme_mod('color-header') ).'; border-bottom-color: rgba(0,0,0,0.1); }
.sticky-element-sticky #header { border-bottom-color: rgba(0,0,0,0.1); }
.site-title a { color: #fff; }
.site-description { color: rgba(255,255,255,0.7); }
#header .social-links { border-left-color: rgba(255,255,255,0.3); }
#header .social-links .social-tooltip { color: rgba(255,255,255,0.8); }
#header .social-links .social-tooltip:hover { color: #fff; }
.toggle-search { color: rgba(255,255,255,0.8); }
.toggle-search:hover,
.toggle-search.active { color: #fff; }
@media only screen and (min-width: 720px) {
	#nav-header .nav > li > a { color: rgba(255,255,255,0.8); }	
	#nav-header .nav > li > a:hover, 
	#nav-header .nav > li:hover > a { color: #fff; }
	#nav-header .nav > li.current_page_item > a, 
	#nav-header .nav > li.current-menu-item > a,
	#nav-header .nav > li.current-menu-ancestor > a,
	#nav-header .nav > li.current-post-parent > a { color: #fff; }
}
@media only screen and (max-width: 719px) {
	.site-title { border-bottom-color: rgba(255,255,255,0.2)!important; }
}
				'."\n";
			}
			// comment bubble color
			if ( get_theme_mod('color-comment-bubble','#eeeeee') != '#eeeeee' ) {
				$styles .= '
.featured-post-comments,
.entry-header .entry-meta .entry-comments { color: '.esc_attr( get_theme_mod('color-comment-bubble') ).'; }
.featured-post-comments span,
.entry-header .entry-meta .entry-comments span { color: #fff; }
				'."\n";
			}
			// category color
			if ( get_theme_mod('color-category','#eeeeee') != '#eeeeee' ) {
				$styles .= '
.entry-header .entry-meta .entry-category a { background: '.esc_attr( get_theme_mod('color-category') ).'; color: rgba(255,255,255,0.8); }
				'."\n";
			}
			// footer menu color
			if ( get_theme_mod('color-footer-menu','#ffffff') != '#ffffff' ) {
				$styles .= '
#nav-footer.nav-container,
#footer-bottom #back-to-top { background: '.esc_attr( get_theme_mod('color-footer-menu') ).'; }
#footer-bottom #back-to-top { color: #fff; }
#footer-bottom #back-to-top:hover { color: rgba(255,255,255,0.8); }
#nav-footer .nav-toggle { color: #fff; }
@media only screen and (min-width: 720px) {
	#nav-footer .nav > li > a { color: rgba(255,255,255,0.8); }	
	#nav-footer .nav > li > a:hover, 
	#nav-footer .nav > li:hover > a { color: #fff; }
	#nav-footer .nav > li.current_page_item > a, 
	#nav-footer .nav > li.current-menu-item > a,
	#nav-footer .nav > li.current-menu-ancestor > a,
	#nav-footer .nav > li.current-post-parent > a { color: #fff; }
}
@media only screen and (max-width: 719px) {
	#nav-footer .nav li a { color: rgba(255,255,255,0.8); border-top-color: rgba(255,255,255,0.2); }	
	#nav-footer .nav li > a:hover { background: rgba(0,0,0,0.05); color: #fff; }
	#nav-footer .nav li.current_page_item > a, 
	#nav-footer .nav li.current-menu-item > a,
	#nav-footer .nav li.current-post-parent > a { background: rgba(0,0,0,0.05); color: #fff; }
}
#footer { border-top: 0; }
				'."\n";
			}
			// footer color
			if ( get_theme_mod('color-footer','#eeeeee') != '#eeeeee' ) {
				$styles .= '
#footer { background: '.esc_attr( get_theme_mod('color-footer') ).'; }
#footer-bottom a { color: #fff; }
#footer-bottom a:hover { color: rgba(255,255,255,0.8); }
#footer-bottom #copyright, 
#footer-bottom #credit { color: rgba(255,255,255,0.7); }
#footer-bottom .social-links a { color: rgba(255,255,255,0.7); }
#footer-bottom .social-links a:hover { color: #fff; }
#footer-bottom .social-links .social-tooltip:hover:after { background: #fff; color: #666; }
#footer-bottom .social-links .social-tooltip:hover:before { border-color: #fff transparent; }
				'."\n";
			}
			// header logo max-height
			if ( get_theme_mod('logo-max-height','60') != '60' ) {
				$styles .= '.site-title a img { max-height: '.esc_attr( get_theme_mod('logo-max-height') ).'px; }'."\n";
			}
			// header text color
			if ( get_theme_mod( 'header_textcolor' ) != '' ) {
				$styles .= '.site-title a, .site-description { color: #'.esc_attr( get_theme_mod( 'header_textcolor' ) ).'; }'."\n";
			}
			wp_add_inline_style( 'minimer-style', $styles );	
		}
	}
	
}
add_action( 'wp_enqueue_scripts', 'minimer_dynamic_css' );
